//+------------------------------------------------------------------+
//|                                                        HA_WR.mq4 |
//+------------------------------------------------------------------+
#property copyright "rene"
#property link      "//http://www.forex-tsd.com/suggestions-trading-systems/19029-my-simple-easy-use-system.html"


//http://www.forex-tsd.com/suggestions-trading-systems/19029-my-simple-easy-use-system.html

//---- input parameters
extern int     MaxOrders   =  1;
extern int     MAPeriod    =  14;
extern int     WRPeriod    =  14;
extern string  EAname      =  "HA_WR";
extern int     Slippage    = 5;
extern double  LotSize     = 0.1;
extern int     MagicNumber = 123456;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   //Heiken Ashi. 1.High, 2.Low, 3.Open, 4.Close
   double HAHigh1,HALow1,HAOpen1,HAClose1;
   double HAHigh2,HALow2,HAOpen2,HAClose2;
   int buyorsell;
   HAHigh1 = iCustom(NULL,0,"Heiken Ashi",0,1);
   HALow1 = iCustom(NULL,0,"Heiken Ashi",1,1);
   HAOpen1 = iCustom(NULL,0,"Heiken Ashi",2,1);
   HAClose1 = iCustom(NULL,0,"Heiken Ashi",3,1);
   
   HAHigh2 = iCustom(NULL,0,"Heiken Ashi",0,0);
   HALow2 = iCustom(NULL,0,"Heiken Ashi",1,0);
   HAOpen2 = iCustom(NULL,0,"Heiken Ashi",2,0);
   HAClose2 = iCustom(NULL,0,"Heiken Ashi",3,0);   
   //EMA 14, Close
   double EMA1, EMA2;
   EMA1 = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   EMA2 = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   //WR
   double WR;
   WR = iWPR(NULL,0,WRPeriod,0);
   string commt;
   commt = commenttxt();
   //for BUY signal
   //check for 2 white HA 
   string HA1, HA2;
   if (localorders()<  MaxOrders ){
      //open order
      HA1 = CheckHA(HAOpen1,HAClose1);
      HA2 = CheckHA(HAOpen2,HAClose2);
      if(HA1 != HA2) return(0);
      if(HA2 == "white"){
	      //and 2x cross EMA 
	      if((HAClose1 > EMA1)&&(HAClose2 > EMA2)&&(WR > (-20))){
            OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage,0,0,commt,MagicNumber,0,Blue);
            return(0);
	      }
      }else{
		//and 2x cross EMA 
	      if((HAClose1 < EMA1)&&(HAClose2 < EMA2)&&(WR < (-80))){
            OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage,0,0,commt,MagicNumber,0,Red);
            return(0);
	      }
	   }
   }else{
      //trace Order
      //get order type
      buyorsell = getOrderType();
      if (buyorsell == 0){
         if(WR < (-20))closeOrder(OP_BUY);
      }else{
         if(WR > (-80))closeOrder(OP_SELL);
      }
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//define comment
string commenttxt(){
   string commt = Symbol()+" BY "+ EAname;
   return (commt);
}
// check local order number
int localorders()
{
   int Lorder=0;
   int total;
   string commt = commenttxt();
   for (total =0; total<OrdersTotal(); total++)
   {
      OrderSelect(total,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) Lorder++; 
   }
   return(Lorder);
}
//0: buy, 1:sell, 
//2: buy limit pending, 3: sell limit pending
//4: buy stop pending, 5: sell stop pending
int getOrderType(){
   int type;
   int total;
   string commt = commenttxt();
   for (total =0; total<OrdersTotal(); total++)
   {
      OrderSelect(total,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) type = OrderType();
   }
   return(type);
}


//close Order
bool closeOrder(int type){
   int total;
   for (total =0; total<OrdersTotal(); total++){
      OrderSelect(total,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber() == MagicNumber) {
         if(type==OP_BUY)
            return (OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Gold));
         if(type==OP_SELL)   
            return (OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet));
      }
   }
}

string CheckHA(double open, double close){
   if(open > close) return("red");
   if(open < close) return("white");
}